【POJ3071】Football - 状态压缩+期望 DP

Description

Consider a single-elimination football tournament involving 2n teams, denoted 1, 2, …, 2n. In each round of the tournament, all teams still in the tournament are placed in a list in order of increasing index. Then, the first team in the list plays the second team, the third team plays the fourth team, etc. The winners of these matches advance to the next round, and the losers are eliminated. After n rounds, only one team remains undefeated; this team is declared the winner.

Given a matrix P = [pij] such that pij is the probability that team i will beat team j in a match determine which team is most likely to win the tournament.

Input

The input test file will contain multiple test cases. Each test case will begin with a single line containing n (1 ≤ n ≤ 7). The next 2n lines each contain 2n values; here, the jth value on the ith line represents pij. The matrix P will satisfy the constraints that pij = 1.0 − pji for all i ≠ j, and pii = 0.0 for all i. The end-of-file is denoted by a single line containing the number −1. Note that each of the matrix entries in this problem is given as a floating-point value. To avoid precision problems, make sure that you use either the double data type instead of float.

Output

The output file should contain a single line for each test case indicating the number of the team most likely to win. To prevent floating-point precision issues, it is guaranteed that the difference in win probability for the top two teams will be at least 0.01.

题目大意

给你$2^n$个球队,必须相邻的球队才可以比赛,在告诉你i球队战胜j球队的概率,问最后哪支球队赢得概率最大。

思路

设$f_{i,j}$表示第$i$次比赛队伍$j$获胜的概率,枚举与$j$比赛的$k$,可得$f_{i,j} = \sum_{k=1}^{2^n}f_{i-1,j}*f_{i-1,k}*p_{j,k}*[$ $\text{j与k相邻} ]$

判断相邻先<<(i-1)再用异或(^)运算判断一下即可

/************************************************
*Author        :  lrj124
*Created Time  :  2018.09.30.19:13
*Mail          :  [email protected]
*Problem       :  poj3071
************************************************/
#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
const int maxn = (1<<7) + 10;
double p[maxn][maxn],f[maxn][maxn];
int n;
int main() {
	while (cin >> n) {
		if (n == -1) break;
		memset(f,0,sizeof(f));
		for (int i = 1;i <= (1<<n);i++) {
			f[0][i] = 1;
			for (int j = 1;j <= (1<<n);j++) scanf("%lf",&p[i][j]);
		}
		for (int i = 1;i <= (1<<n);i++)
			for (int j = 1;j <= (1<<n);j++)
				for (int k = 1;k <= (1<<n);k++)
					if ((((j-1)>>(i-1))^1) == ((k-1)>>(i-1)))
						f[i][j] += f[i-1][j]*f[i-1][k]*p[j][k];
		double Max = 0;
		int ans;
		for (int i = 1;i <= (1<<n);i++)
			if (f[n][i] > Max) {
				Max = f[n][i];
				ans = i;
			}
		printf("%d\n",ans);
	}
	return 0;
}

原文地址:https://www.cnblogs.com/lrj124/p/9733377.html

时间: 2024-10-10 11:01:40

【POJ3071】Football - 状态压缩+期望 DP的相关文章

hdu4352---XHXJ&#39;s LIS(状态压缩数位dp)

一开始我设计的状态是dp[i][j][sta],表示第i位为j,然后状态为sta,后来发现这样会导致后面的计算直接return,得不到正确答案 重新设计状态dp[i][k][sta]表示i位数,lis=k,状态为sta的个数,这里求LIS用的是O(nlogn)求法的思想 /************************************************************************* > File Name: hdu4352.cpp > Author: ALe

[HDU 4336] Card Collector (状态压缩概率dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4336 题目大意:有n种卡片,需要吃零食收集,打开零食,出现第i种卡片的概率是p[i],也有可能不出现卡片.问你收集齐n种卡片,吃的期望零食数是多少? 状态压缩:f[mask],代表收集齐了mask,还需要吃的期望零食数. 打开包装,有3种情况,第一种:没有卡片,概率(1-sigma(p[i])) 第二种,在已知种类中:概率sigma(p[j]) 第三种,在未知种类中:p[k] 因此 f[mask]

TYVJ 2054 [Nescaf&#233;29]四叶草魔杖 最小生成树 状态压缩/背包DP

$ \rightarrow $ 戳我进TYVJ原题 [Nescafé29]四叶草魔杖 题目限制 时间限制 内存限制 评测方式 题目来源 1000ms 131072KiB 标准比较器 Local 题目背景 陶醉在彩虹光芒笼罩的美景之中,探险队员们不知不觉已经穿过了七色虹, 到达了目的地,面前出现了一座城堡和小溪田园,城堡前的木牌上写着"Poetic Island". "这一定就是另外两位护法的所在地了--我们快进去吧!" 探险队员们快步进入了城堡,城堡大厅的羊毛沙发上

状态压缩插头DP

HDU 1693   Eat the Trees http://www.cnblogs.com/zhuangli/archive/2008/09/04/1283753.html http://blog.csdn.net/xymscau/article/details/6756351 题意:在N*M(1<=N, M<=11)的矩阵中,有些格子有树,没有树的格子不能到达,找一条或多条回路,吃完所有的树,求有多少种方法. 分析:轮廓线表示当前插头的状态,这题中状态中1表示有插头,0表示无插头.如果是

【Luogu】P2258子矩阵(状态压缩,DP)

233今天蒟蒻我连文化课都没听光想着这个了 然后我调了一下午终于过了!!! 一看数据范围似乎是状压,然而216等于65536.开一个65536*65536的二维数组似乎不太现实. 所以Rqy在四月还是几月给我们讲这道题的时候说要半DFS半DP,时间复杂度O(2n*n3) 怎么个半DFS半DP法呢? 其实我没DFS.所以这个问题不重要. 我真的没用DFS.枚举从1到2n-1的所有集合,把二进制数中1的个数不等于r的都筛掉.然后对于每个状态,预处理出每一列内部的代价,预处理出列与列之间的代价,然后进

[bzoj1072][SCOI2007][排列perm] (状态压缩+数位dp+排列去重)

Description 给一个数字串s和正整数d, 统计s有多少种不同的排列能被d整除(可以有前导0).例如123434有90种排列能被2整除,其中末位为2的有30种,末位为4的有60种. Input 输入第一行是一个整数T,表示测试数据的个数,以下每行一组s和d,中间用空格隔开.s保证只包含数字0, 1, 2, 3, 4, 5, 6, 7, 8, 9. Output 每个数据仅一行,表示能被d整除的排列的个数. Sample Input 7 000 1 001 1 1234567890 1 1

HDU 4336 Card Collector (期望DP+状态压缩 或者 状态压缩+容斥)

题意:有N(1<=N<=20)张卡片,每包中含有这些卡片的概率,每包至多一张卡片,可能没有卡片.求需要买多少包才能拿到所以的N张卡片,求次数的期望. 析:期望DP,是很容易看出来的,然后由于得到每张卡片的状态不知道,所以用状态压缩,dp[i] 表示这个状态时,要全部收齐卡片的期望. 由于有可能是什么也没有,所以我们要特殊判断一下.然后就和剩下的就简单了. 另一个方法就是状态压缩+容斥,同样每个状态表示收集的状态,由于每张卡都是独立,所以,每个卡片的期望就是1.0/p,然后要做的就是要去重,既然

POJ 3254 Corn Fields 状态压缩DP (C++/Java)

http://poj.org/problem?id=3254 题目大意: 一个农民有n行m列的地方,每个格子用1代表可以种草地,而0不可以.放牛只能在有草地的,但是相邻的草地不能同时放牛, 问总共有多少种方法. 思路: 状态压缩的DP. 可以用二进制数字来表示放牧情况并判断该状态是否满足条件. 这题的限制条件有两个: 1.草地限制. 2.相邻限制. 对于草地限制,因为输入的时候1是可以种草地的. 以"11110"草地分析,就只有最后一个是不可以种草的.取反后得00001  .(为啥取反

2017盛大游戏杯 零件组装(状态压缩DP之巧妙枚举子集)

题目链接:2017盛大游戏杯 零件组装 题意: 有n个零件,给你相邻关系和排斥关系,每两块零件组装起来有一个代价,问最少的代价总和是多少. 题解: 考虑状态压缩,dp[i]表示i这个集合为一个零件块. 那么要枚举一下i的子集.O(3^n). 先要预处理一下每个集合的排斥个数和相邻个数,然后容斥一下就可以了. 1 #include<bits/stdc++.h> 2 #define mst(a,b) memset(a,b,sizeof(a)) 3 #define F(i,a,b) for(int